SystemOrganization addCategory: #'SeasideGallery-Views'!
SystemOrganization addCategory: #'SeasideGallery-Model'!
SystemOrganization addCategory: #'SeasideGallery-Util'!

WAComponent subclass: #SgGalleryComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-Views'!

!SgGalleryComponent class methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 11:51:17.416'!
setup

	| application |
	application := WAAdmin register: self asApplicationAt: 'gallery'.
	application
		preferenceAt: #sessionClass put: SgSession;
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary! !

!SgGalleryComponent methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 11:25'!
children

	^ Array new! !

!SgGalleryComponent methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 11:24'!
initialize

	super initialize! !

!SgGalleryComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 11:53:03.99'!
removeData

	SgFilePool new reset.
	SgImage findAll do: [ :each | each delete ].
	SgGallery findAll do: [ :each | each delete ].! !

!SgGalleryComponent methodsFor: 'as yet unclassified' stamp: 'HK 11/1/2010 10:29:59.733'!
renderContentOn: html

	self renderLoginOn: html! !

!SgGalleryComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 11:53:03.978'!
renderFilesOn: html

	SgImage findAll do: [ :each |
		html div with: [
			html paragraph: each fileName.
			html image url: (SgFilePool new urlForFile: each fileName)
			]
		]! !

!SgGalleryComponent methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 11:28'!
renderHeadingOn: html

	html heading level: 1; with: 'Seaside Gallery'! !

!SgGalleryComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 11:45:14.513'!
renderLoginOn: html

	html div with: (SgLoginComponent new)! !

!SgGalleryComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 11:45:26.768'!
renderPlaygroundOn: html

	html anchor callback: [
		self call: (SgMetaEditorComponent new)
		]; with: 'Edit'! !

!SgGalleryComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 11:45:37.174'!
renderUploaderOn: html

	html div with: (SgUploaderComponent new)! !

WAComponent subclass: #SgLoginComponent
	instanceVariableNames: 'username password messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-Views'!

!SgLoginComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 15:13:37.855'!
children

	^ Array with: self messageComponent.! !

!SgLoginComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 15:14:15.101'!
initialize

	super initialize.
	self messageComponent: SgMessageComponent new..! !

!SgLoginComponent methodsFor: 'accessing' stamp: 'LT 11/1/2010 15:12:28.307'!
messageComponent
	^ messageComponent! !

!SgLoginComponent methodsFor: 'accessing' stamp: 'LT 11/1/2010 15:12:28.313'!
messageComponent: anObject
	messageComponent := anObject! !

!SgLoginComponent methodsFor: 'accessing' stamp: 'HK 11/1/2010 10:19:29.322'!
password
	^ password! !

!SgLoginComponent methodsFor: 'accessing' stamp: 'HK 11/1/2010 10:19:29.334'!
password: anObject
	password := anObject! !

!SgLoginComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 15:15:43.926'!
renderContentOn: html

	html form: 
		[self
			renderHeadingOn: html;
			renderUserNameOn: html;
			renderPasswordInputOn: html;
			renderSubmitButtonOn: html;
			renderRegisterLinkOn: html].! !

!SgLoginComponent methodsFor: 'as yet unclassified' stamp: 'HK 11/1/2010 10:24:13.242'!
renderHeadingOn: html

	html heading: 'Login'! !

!SgLoginComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 14:24:20.87'!
renderPasswordInputOn: html

	html div with:
		[ html span 
			class: 'loginLabel'; 
			with: 'Password'.
		html span with:
			[ html passwordInput on: #password of: self ]].! !

!SgLoginComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 14:53:43.128'!
renderPasswordOn: html

	html text: self errorMessage.! !

!SgLoginComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 14:55:05.574'!
renderRegisterLinkOn: html

	html anchor 
		callback: [self answer: #registerUser];
		with: 'Register'.! !

!SgLoginComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 15:02:51.709'!
renderSubmitButtonOn: html

	html submitButton
		callback: [self tryToLogin];
		with: 'Login'.! !

!SgLoginComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 14:23:58.113'!
renderUserNameOn: html

	html div with:
		[ html span 
			class: 'label'; 
			with: 'Username'.
		html span with:
			[ html textInput 
				on: #username 
				of: self ]].! !

!SgLoginComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 15:15:15.779'!
tryToLogin

	| user |
	user := self validateLogin.
	(user isNil)
		ifTrue: [self messageComponent message: 'Wrong password or username']
		ifFalse: [self answer: user].! !

!SgLoginComponent methodsFor: 'accessing' stamp: 'LT 11/1/2010 14:24:57.732'!
username

	^ username! !

!SgLoginComponent methodsFor: 'accessing' stamp: 'LT 11/1/2010 14:25:05.219'!
username: anObject

	username := anObject! !

!SgLoginComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 14:43:00.958'!
validateLogin

	| user |
	user := SgUser 
		find: [ :each | each username = self username]
		ifAbsent: [^ nil].
	(user validatePassword: self password)
		ifTrue: [^ user]
		ifFalse: [^ nil]! !

WAComponent subclass: #SgMessageComponent
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-Views'!

!SgMessageComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 15:10:53.021'!
initialize

	super initialize.
	self message: ''.! !

!SgMessageComponent methodsFor: 'accessing' stamp: 'LT 11/1/2010 15:06:59.308'!
message
	^ message! !

!SgMessageComponent methodsFor: 'accessing' stamp: 'LT 11/1/2010 15:06:59.321'!
message: anObject
	message := anObject! !

!SgMessageComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 15:10:19.589'!
renderContentOn: html
	
	html div 
		class: 'message';
		with: [html text: [self message]].! !

WAComponent subclass: #SgMetaEditorComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-Views'!

!SgMetaEditorComponent methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 12:07'!
renderContentOn: html

	html text: 'Hallo'! !

WAComponent subclass: #SgRegisterComponent
	instanceVariableNames: 'user repeatedPassword'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-Views'!

!SgRegisterComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 14:08:38.031'!
initialize

	self user: SgUser new.! !

!SgRegisterComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 14:18:22.066'!
isNewUserValid

	^ self isUserDataCompleted and: ["self doPasswordCorrespond and: [self isUsernameAvailable]" true] ! !

!SgRegisterComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 14:17:43.387'!
isUserDataCompleted

	| usernameIsOkay  |
	self halt: 'not used input field: not nil or not empty??'.
	usernameIsOkay := self user username notNil and: [self user username notEmpty].
	^ usernameIsOkay ! !

!SgRegisterComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 14:12:43.158'!
registerUser

	self isNewUserValid ifTrue: 
		[self 
			user save;
			answer: self user].! !

!SgRegisterComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 14:08:59.98'!
renderContentOn: html

	html form: 
		[self 
			renderUsernameInputOn: html;
			renderFirstNameInputOn: html;
			renderLastNameInputOn: html;
			renderPasswortInputOn: html;
			renderRepeatedPasswordInputOn: html;
			renderSubmitButtonOn: html]. ! !

!SgRegisterComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 13:14:23.208'!
renderFirstNameInputOn: html

	html div with: 
		[html span 
			class: 'label';
			with: 'First name'.
		html span with: 
			[html textInput
				on: #firstName
				of: self user]]! !

!SgRegisterComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 13:14:50.929'!
renderLastNameInputOn: html

	html div with: 
		[html span 
			class: 'label';
			with: 'Last name'.
		html span with: 
			[html textInput
				on: #lastName
				of: self user]]! !

!SgRegisterComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 13:07:17.041'!
renderPasswordInputOn: html

	html div with: 
		[html span 
			class: 'label';
			with: 'Password'.
		html span with: 
			[html passwordInput
				on: #password
				of: self user]]! !

!SgRegisterComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 14:09:53.059'!
renderRepeatedPasswordInputOn: html

	html div with: 
		[html span 
			class: 'label';
			with: 'Password repetition'.
		html span with: 
			[html passwordInput
				on: #repeatedPassword
				of: self]]! !

!SgRegisterComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 14:10:51.409'!
renderSubmitButtonOn: html

	html submitButton
		with: 'Register';
		callback: [self registerUser].! !

!SgRegisterComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 13:12:45.942'!
renderUsernameInputOn: html

	html div with: 
		[html span 
			class: 'label';
			with: 'Username'.
		html span with: 
			[html textInput
				on: #username
				of: self user]]! !

!SgRegisterComponent methodsFor: 'accessing' stamp: 'LT 11/1/2010 13:05:19.059'!
user

	^ user
! !

!SgRegisterComponent methodsFor: 'accessing' stamp: 'LT 11/1/2010 13:05:19.069'!
user: aSgUser

	user := aSgUser
! !

WAComponent subclass: #SgUploaderComponent
	instanceVariableNames: 'filePool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-Views'!

!SgUploaderComponent class methodsFor: 'as yet unclassified' stamp: 'HK 10/28/2010 14:41:18.118'!
supportedFileTypes

	^ Array
		with: 'image/gif'
		with: 'image/png'
		with: 'image/jpeg'! !

!SgUploaderComponent methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 11:43'!
filePool

	^ filePool! !

!SgUploaderComponent methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 11:43'!
filePool: aLibrary

	filePool := aLibrary! !

!SgUploaderComponent methodsFor: 'as yet unclassified' stamp: 'HK 10/28/2010 14:40:21.575'!
fileTypeIsSupportedFor: aFile


	^ self class supportedFileTypes includes: (aFile contentType greaseString)
	! !

!SgUploaderComponent methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 11:49'!
initialize

	super initialize.
	self filePool: (SgFilePool new)! !

!SgUploaderComponent methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 11:50'!
renderContentOn: html

	self renderFormOn: html! !

!SgUploaderComponent methodsFor: 'as yet unclassified' stamp: 'HK 10/28/2010 15:50:27.31'!
renderFormOn: html

	html form multipart; with: [
		html fileUpload callback: [ :newFile |
			self uploadFile: newFile.
			].
		html submitButton: 'Upload'
		]! !

!SgUploaderComponent methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 11:53:03.997'!
uploadFile: aFile

	| uploadedPicture |
	
	(self fileTypeIsSupportedFor: aFile) ifTrue: [
		self filePool addFile: aFile.
		uploadedPicture := SgImage new
			title: aFile fileName;
			fileName: aFile fileName.
		uploadedPicture save.
		
		]! !

SDActiveRecord subclass: #SgGallery
	instanceVariableNames: 'title owner isPublic created pictures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-Model'!

!SgGallery methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 08:15'!
initialize

	super initialize.! !

!SgGallery methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 08:16'!
size! !

SDActiveRecord subclass: #SgImage
	instanceVariableNames: 'title fileName thumbnail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-Model'!

!SgImage class methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 12:14'!
thumbnailSize

	^ 100! !

!SgImage methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 12:13'!
createThumbnail! !

!SgImage methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 13:12'!
fileName
	^ fileName! !

!SgImage methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 12:13'!
fileName: anObject
	fileName := anObject! !

!SgImage methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 12:12'!
title: aString
	title := aString! !

SDActiveRecord subclass: #SgUser
	instanceVariableNames: 'hashedPassword username firstName lastName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-Model'!

!SgUser class methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 14:32:10.424'!
hashPassword: aString

	^ GRPlatform current secureHashFor: aString! !

!SgUser methodsFor: 'accessing' stamp: 'LT 11/1/2010 13:13:32.603'!
firstName
	^ firstName! !

!SgUser methodsFor: 'accessing' stamp: 'LT 11/1/2010 13:13:32.613'!
firstName: anObject
	firstName := anObject! !

!SgUser methodsFor: 'accessing' stamp: 'LT 11/1/2010 14:30:18.923'!
hashedPassword
	^ hashedPassword! !

!SgUser methodsFor: 'accessing' stamp: 'LT 11/1/2010 14:30:18.933'!
hashedPassword: anObject
	hashedPassword := anObject! !

!SgUser methodsFor: 'accessing' stamp: 'LT 11/1/2010 13:13:32.623'!
lastName
	^ lastName! !

!SgUser methodsFor: 'accessing' stamp: 'LT 11/1/2010 13:13:32.629'!
lastName: anObject
	lastName := anObject! !

!SgUser methodsFor: 'accessing' stamp: 'LT 11/1/2010 13:07:57.87'!
username
	^ username! !

!SgUser methodsFor: 'accessing' stamp: 'LT 11/1/2010 13:08:02.341'!
username: anObject
	username := anObject! !

!SgUser methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 14:38:59.831'!
validatePassword: aString

	| passwordHash |
	passwordHash := self class hashPassword: aString.
	^ self hashedPassword = passwordHash! !

WAFileLibrary subclass: #SgFilePool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-Views'!

!SgFilePool methodsFor: 'uploaded' stamp: 'HK 10/28/2010 14:30:30.173'!
reset

	self filenames do: [ :each |
		self removeFile: each
		]! !

!SgFilePool methodsFor: 'uploaded' stamp: 'LT 11/1/2010 13:00:21.957'!
styleCss
	^ '.label {
	display: block;
	width: 200px;
	}'! !

Object subclass: #SgInstaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-Util'!

!SgInstaller class methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 14:22:37.914'!
setup

	| application |
	application := WAAdmin register: SgRootTask asApplicationAt: 'gallery'.
	application
		preferenceAt: #sessionClass put: SgSession;
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary! !

WATask subclass: #SgRootTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-Views'!

!SgRootTask methodsFor: 'as yet unclassified' stamp: 'LT 11/1/2010 15:00:20.626'!
go

	| loginAnswer user |
	loginAnswer := self call: SgLoginComponent new.
	loginAnswer = #registerUser 
		ifTrue: [user := self call: SgRegisterComponent new.]
		ifFalse: 
			[user := loginAnswer
			self session login: user.
			self call: SgGallery].
 	self session login: user.
 	self call: SgGalleryComponent new.! !

WASession subclass: #SgSession
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-Views'!

!SgSession methodsFor: 'accessing' stamp: 'LT 11/1/2010 11:40:20.637'!
isLoggedIn

	^ self user notNil! !

!SgSession methodsFor: 'accessing' stamp: 'LT 11/1/2010 11:40:01.183'!
login: aUser

	self user: aUser.! !

!SgSession methodsFor: 'accessing' stamp: 'LT 11/1/2010 11:39:58.831'!
logout

	self user: nil.! !

!SgSession methodsFor: 'accessing' stamp: 'HK 11/1/2010 10:12:21.321'!
user
	^ user! !

!SgSession methodsFor: 'accessing' stamp: 'HK 11/1/2010 10:12:21.331'!
user: anObject
	user := anObject! !
